#pragma once

/**
@file
@brief Cvbg}l[W
@author m
*/

#include "Base.h"

namespace UQ{

/**
Cvbg}l[WNX.
L[{[hEWCpbhEzRg[ɂ͂̊Ǘs܂B\n
zRg[́A assign() Ŋ蓖Ă邱Ƃő̓̓foCXƓlɈƂł܂B\n
zRg[̊蓖ẮAN system.ini ǂݍ܂AIɓt@Cɕۑ܂B\n
[F1]L[ƁAL[RtBO_CAO\܂B
*/
class InputMgr{
public:
	/**
	efoCX̃{^ID.
	L[{[hEWCpbhEzRg[̃{^IDłB
	*/
	enum ButtonID{
		ID_DISABLE = 0,

		K_0, K_1, K_2, K_3, K_4, K_5, K_6, K_7, K_8, K_9,
		K_A, K_B, K_C, K_D, K_E, K_F, K_G, K_H, K_I, K_J, K_K, K_L, K_M, K_N,
		K_O, K_P, K_Q, K_R, K_S, K_T, K_U, K_V, K_W, K_X, K_Y, K_Z,
		K_LEFT, K_RIGHT, K_UP, K_DOWN,
		K_ENTER, K_ESC, K_SPACE, K_TAB,
		K_SHIFT, K_LSHIFT, K_RSHIFT,
		K_CTRL, K_LCTRL, K_RCTRL,
		K_ALT, K_LALT, K_RALT,
		K_NUM0, K_NUM1, K_NUM2, K_NUM3, K_NUM4, K_NUM5, K_NUM6, K_NUM7, K_NUM8, K_NUM9,
		K_NUMPLUS, K_NUMMINUS, K_NUMSTAR, K_NUMSLASH, K_NUMDOT, K_NUMENTER,
		K_F1 , K_F2 , K_F3 , K_F4 , K_F5 , K_F6 , K_F7 , K_F8 , K_F9 , K_F10, K_F11, K_F12,
		K_F13, K_F14, K_F15, K_F16, K_F17, K_F18, K_F19, K_F20, K_F21, K_F22, K_F23, K_F24,

		J1_LEFT, J1_RIGHT, J1_UP, J1_DOWN,
		J1_BTN1, J1_BTN2 , J1_BTN3 , J1_BTN4 , J1_BTN5 , J1_BTN6 , J1_BTN7 , J1_BTN8 ,
		J1_BTN9, J1_BTN10, J1_BTN11, J1_BTN12, J1_BTN13, J1_BTN14, J1_BTN15, J1_BTN16,
		J2_LEFT, J2_RIGHT, J2_UP, J2_DOWN,
		J2_BTN1, J2_BTN2 , J2_BTN3 , J2_BTN4 , J2_BTN5 , J2_BTN6 , J2_BTN7 , J2_BTN8 ,
		J2_BTN9, J2_BTN10, J2_BTN11, J2_BTN12, J2_BTN13, J2_BTN14, J2_BTN15, J2_BTN16,

		VC1_LEFT, VC1_RIGHT, VC1_UP, VC1_DOWN,
		VC1_BTN1, VC1_BTN2 , VC1_BTN3 , VC1_BTN4 , VC1_BTN5 , VC1_BTN6 , VC1_BTN7 , VC1_BTN8 ,
		VC1_BTN9, VC1_BTN10, VC1_BTN11, VC1_BTN12, VC1_BTN13, VC1_BTN14, VC1_BTN15, VC1_BTN16,
		VC2_LEFT, VC2_RIGHT, VC2_UP, VC2_DOWN,
		VC2_BTN1, VC2_BTN2 , VC2_BTN3 , VC2_BTN4 , VC2_BTN5 , VC2_BTN6 , VC2_BTN7 , VC2_BTN8 ,
		VC2_BTN9, VC2_BTN10, VC2_BTN11, VC2_BTN12, VC2_BTN13, VC2_BTN14, VC2_BTN15, VC2_BTN16,

		BUTTON_ID_MAX
	};
	static const int J_COUNT_ = 2;			///< WCpbh̐.
	static const int J_BTN_COUNT_ = 16;		///< WCpbh̃{^.
	static const int VC_COUNT_ = 2;			///< zRg[̐.
	static const int VC_BTN_COUNT_ = 16;	///< zRg[̃{^.

	virtual ~InputMgr(){}

	 /**
	WCpbh̃o[̃{^ID擾.
	@param[in] padNo	WCpbhԍi 1 ` InputMgr::J_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID J_LEFT(int padNo) const = 0;

	/**
	WCpbh̃o[Ẽ{^ID擾.
	@param[in] padNo	WCpbhԍi 1 ` InputMgr::J_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID J_RIGHT(int padNo) const = 0;

	/**
	WCpbh̃o[̃{^ID擾.
	@param[in] padNo	WCpbhԍi 1 ` InputMgr::J_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID J_UP(int padNo) const = 0;

	/**
	WCpbh̃o[̃{^ID擾.
	@param[in] padNo	WCpbhԍi 1 ` InputMgr::J_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID J_DOWN(int padNo) const = 0;

	 /**
	WCpbh̃{^̃{^ID擾.
	@param[in] padNo	WCpbhԍi 1 ` InputMgr::J_COUNT_ j
	@param[in] buttonNo	{^ԍi 1 ` InputMgr::J_BTN_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID J_BTN(int padNo, int buttonNo) const = 0;

	 /**
	zRg[̃o[̃{^ID擾.
	@param[in] padNo	zRg[ԍi 1 ` InputMgr::VC_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID VC_LEFT(int padNo) const = 0;

	/**
	zRg[̃o[Ẽ{^ID擾.
	@param[in] padNo	zRg[ԍi 1 ` InputMgr::VC_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID VC_RIGHT(int padNo) const = 0;

	/**
	zRg[̃o[̃{^ID擾.
	@param[in] padNo	zRg[ԍi 1 ` InputMgr::VC_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID VC_UP(int padNo) const = 0;

	/**
	zRg[̃o[̃{^ID擾.
	@param[in] padNo	zRg[ԍi 1 ` InputMgr::VC_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID VC_DOWN(int padNo) const = 0;

	/**
	zRg[̃{^̃{^ID擾.
	@param[in] padNo	zRg[ԍi 1 ` InputMgr::VC_COUNT_ j
	@param[in] buttonNo	{^ԍi 1 ` InputMgr::VC_BTN_COUNT_ j
	@return {^ID
	*/
	virtual ButtonID VC_BTN(int padNo, int buttonNo) const = 0;
	
	/**
	{^́Ă遄.
	w肵{^Ă邩ǂ擾܂B
	@param[in] buttonID	{^ID
	@retval true Ă
	@retval false ĂȂ
	*/
	virtual bool isDown(ButtonID buttonID) const = 0;

	/**
	{^́ꂽuԁ.
	w肵{^̃t[ŏ߂ĉꂽǂ擾܂B
	@param[in] buttonID	{^ID
	@retval true ꂽuԂł
	@retval false ꂽuԂłȂ
	*/
	virtual bool isPressed(ButtonID buttonID) const = 0;

	/**
	{^́ꂽuԁ.
	w肵{^̃t[ŏ߂ĕꂽǂ擾܂B
	@param[in] buttonID	{^ID
	@retval true ꂽuԂł
	@retval false ꂽuԂłȂ
	*/
	virtual bool isReleased(ButtonID buttonID) const = 0;

	/**
	zRg[ւ̊蓖.
	zRg[ւ̊蓖ẴftHglݒ肵܂B4܂Ŋ蓖ĉ\łB\n
	keyconfig.dat ŊɊ蓖ĂĂꍇAD悵܂B\n
	@param[in] vcButtonID	zRg[̃{^̃{^ID
	@param[in] assignName	zRg[̃{^̖O
	@param[in] assign1		蓖Ă{^̃{^ID
	@param[in] assign2		蓖Ă{^̃{^ID
	@param[in] assign3		蓖Ă{^̃{^ID
	@param[in] assign4		蓖Ă{^̃{^ID
	*/
	virtual void assign(
		ButtonID vcButtonID,
		const char* assignName,
		ButtonID assign1 = ID_DISABLE,
		ButtonID assign2 = ID_DISABLE,
		ButtonID assign3 = ID_DISABLE,
		ButtonID assign4 = ID_DISABLE
	) = 0;

	static const int ASSIGN_COUNT_ = 4; ///< zRg[ւ̊蓖Đ.
};

} // namespace UQ
