#pragma once

/**
@file
@brief ^XNE^XN}l[W
@author m
*/

#include "Base.h"

namespace UQ{

/**
^XNNX.
^XNɌpĂB\n
p̃NXŁA update() E render() ̂ǂ炩A܂͗I[o[ChĂB
*/
class DLL_EXPORT Task{
	friend class TaskMgrImpl;

public:
	static const int NOT_INSERT_ = 0x8000; ///< ^XNXg}.

public:
	/**
	RXgN^.
	RXgN^łB\n
	ōXVD揇ʁA`sʂw肵܂B\n
	updatePriority  Task::NOT_INSERT_ w肷ƁAXV^XNXgɂ͑}܂B\n
	renderPriority ɂĂlłB
	@param[in] updatePriority	XVD揇
	@param[in] renderPriority	`D揇
	*/
	Task(int updatePriority = NOT_INSERT_, int renderPriority = NOT_INSERT_);
	virtual ~Task();

	/**
	XV.
	^XN̍XVp\bhłB
	*/
	virtual void update(void){}

	/**
	`.
	^XN̕`p\bhłB
	*/
	virtual void render(void){}

	/**
	폜.
	^XN̍폜s܂B\n
	t[̏IɃ܂B\n
	q^XNĂꍇAq^XN폜܂B
	*/
	void erase(void);

	/**
	XVꎞ~.
	^XN̍XVi update() ̌Ăяojꎞ~܂B\n
	q^XNĂꍇAq^XNǐ܂B
	*/
	void pauseUpdate(void);

	/**
	XVꎞ~.
	^XN̍XVi update() ̌Ăяoj̈ꎞ~܂B\n
	q^XNĂꍇAq^XNǐ܂B
	*/
	void resumeUpdate(void);

	/**
	`ꎞ~.
	^XN̕`i render() ̌Ăяojꎞ~܂B\n
	q^XNĂꍇAq^XNǐ܂B
	*/
	void pauseRender(void);

	/**
	`ꎞ~.
	^XN̕`i render() ̌Ăяoj̈ꎞ~܂B\n
	q^XNĂꍇAq^XNǐ܂B
	*/
	void resumeRender(void);

	/**
	XVD揇ʂ̎擾.
	XVD揇ʂ擾܂B
	@return XVD揇
	*/
	int getUpdatePriority(void) const;

	/**
	`D揇ʂ̎擾.
	`D揇ʂ擾܂B
	@return `D揇
	*/
	int getRenderPriority(void) const;

	/**
	XVD揇ʂ̐ݒ.
	XVD揇ʂݒ肵܂B\n
	t[̏Iɕёւs܂B
	@param[in] updatePriority	XVD揇
	*/
	void setUpdatePriority(int updatePriority);

	/**
	`D揇ʂ̐ݒ.
	`D揇ʂݒ肵܂B\n
	t[̏Iɕёւs܂B
	@param[in] renderPriority	`D揇
	*/
	void setRenderPriority(int renderPriority);

private:
	struct Impl;
	Impl* pImpl_;
};

class TypeToInt{
public:
	template<typename T> static unsigned int value(void){static unsigned int r = count(); return r;}
private:
	static unsigned int count(void){static unsigned int r = 0; return r++;}
};

/**
^XN}l[WNX.
^XN̊Ǘs܂B\n
^XN insert() ő}ĂB\n
}邱ƂŁAt[ Task::update() E Task::render() Ăяo܂B\n
܂AVXeIɑ}^XN̑SĂ܂B
*/
class DLL_EXPORT TaskMgr{
public:
	virtual ~TaskMgr(){}

	/**
	^XN̑}.
	^XN}܂B\n
	@param[in] pTask	^XÑ|C^
	@param[in] pParent	e^XÑ|C^
	*/
	template<typename T> void insert(T* pTask, Task* pParent = 0){insertImpl(TypeToInt::value<T>(), pTask, pParent);}

	/**
	^XN̑S폜.
	^XNSĂɑ΂č폜s܂B\n
	t[̏IɃ܂B
	*/
	virtual void clear(void) = 0;

	/**
	^XN̐グ.
	w肵^̃^XŇ擾܂B
	@return ^XŇ
	*/
	template<typename T> unsigned int count(void) const{return countImpl(TypeToInt::value<T>());}

	/**
	^XN̗.
	w肵^̂^XN擾܂B\n
	̊֐ count() ɂAw肵^̑SẴ^XN񋓂ł܂B
	@param[in] index	CfbNXi 0 ` count() - 1 ̒lj
	@return ^XÑ|C^
	*/
	template<typename T> T* enumerate(unsigned int index) const{return static_cast<T*>(enumerateImpl(TypeToInt::value<T>(), index));}

	/**
	^XN̎擾.
	w肵^̃^XN擾܂B\n
	^̃^XNꍇA̓1Ԃ܂B\n
	w肷^̃^XN1łꍇɎgƗLłB\n
	ȂꍇA 0 Ԃ܂B
	@return ^XÑ|C^
	*/
	template<typename T> T* get(void) const{return static_cast<T*>(enumerateImpl(TypeToInt::value<T>(), 0));}

private:
	virtual void insertImpl(unsigned int, Task*, Task*) = 0;
	virtual unsigned int countImpl(unsigned int) const = 0;
	virtual Task* enumerateImpl(unsigned int, unsigned int) const = 0;
};

} // namespace UQ
