#pragma once

#include "common.h"
#include "../Include/AudioMgr.h"
#include <memory>

class CIniFileA;

namespace UQ{

class SoundMgr;
class MusicMgr;
class SoundMgrImpl;
class MusicMgrImpl;

class AudioMgrImpl : public AudioMgr{
public:
	AudioMgrImpl();
	~AudioMgrImpl();

	float getVolume(void) const{return volume_;}
	void setVolume(float volume);
	SoundMgr* getSoundMgr(void) const;
	MusicMgr* getMusicMgr(void) const;

private:
	float volume_;
	std::unique_ptr<SoundMgrImpl> pSoundMgr_;
	std::unique_ptr<MusicMgrImpl> pMusicMgr_;
};

} // namespace UQ